test/test_flac.sh : Add --force-raw-format as needed.
[flac.git] / test / test_grabbag.sh
index 6cd743f..dfa4a84 100755 (executable)
@@ -1,43 +1,81 @@
-#!/bin/sh
+#!/bin/bash -e
 
 #  FLAC - Free Lossless Audio Codec
-#  Copyright (C) 2001,2002,2003  Josh Coalson
+#  Copyright (C) 2001-2009  Josh Coalson
+#  Copyright (C) 2011-2013  Xiph.Org Foundation
 #
-#  This program is part of FLAC; you can redistribute it and/or
-#  modify it under the terms of the GNU General Public License
-#  as published by the Free Software Foundation; either version 2
-#  of the License, or (at your option) any later version.
+#  This file is part the FLAC project.  FLAC is comprised of several
+#  components distributed under different licenses.  The codec libraries
+#  are distributed under Xiph.Org's BSD-like license (see the file
+#  COPYING.Xiph in this distribution).  All other programs, libraries, and
+#  plugins are distributed under the GPL (see COPYING.GPL).  The documentation
+#  is distributed under the Gnu FDL (see COPYING.FDL).  Each file in the
+#  FLAC distribution contains at the top the terms under which it may be
+#  distributed.
 #
-#  This program is distributed in the hope that it will be useful,
-#  but WITHOUT ANY WARRANTY; without even the implied warranty of
-#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#  GNU General Public License for more details.
-#
-#  You should have received a copy of the GNU General Public License
-#  along with this program; if not, write to the Free Software
-#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
+#  Since this particular file is relevant to all components of FLAC,
+#  it may be distributed under the Xiph.Org license, which is the least
+#  restrictive of those mentioned above.  See the file COPYING.Xiph in this
+#  distribution.
 
-die ()
-{
-       echo $* 1>&2
-       exit 1
-}
+source common.sh
 
-LD_LIBRARY_PATH=../src/libFLAC/.libs:../src/share/grabbag/.libs:../obj/release/lib:../obj/debug/lib:$LD_LIBRARY_PATH
-export LD_LIBRARY_PATH
-PATH=../src/test_grabbag/cuesheet:../obj/release/bin:../obj/debug/bin:$PATH
+PATH=../src/test_grabbag/cuesheet:$PATH
+PATH=../src/test_grabbag/picture:$PATH
+PATH=../objs/$BUILD/bin:$PATH
 
 test_cuesheet -h 1>/dev/null 2>/dev/null || die "ERROR can't find test_cuesheet executable"
+test_picture -h 1>/dev/null 2>/dev/null || die "ERROR can't find test_picture executable"
 
 run_test_cuesheet ()
 {
-       if [ "$FLAC__VALGRIND" = yes ] ; then
-               valgrind --leak-check=yes --show-reachable=yes --num-callers=100 --logfile-fd=4 test_cuesheet $* 4>>test_grabbag.valgrind.log
+       if [ x"$FLAC__TEST_WITH_VALGRIND" = xyes ] ; then
+               echo "valgrind --leak-check=yes --show-reachable=yes --num-callers=50 test_cuesheet $*" >>test_grabbag.valgrind.log
+               valgrind --leak-check=yes --show-reachable=yes --num-callers=50 --log-fd=4 test_cuesheet${EXE} $* 4>>test_grabbag.valgrind.log
+       else
+               test_cuesheet${EXE} $*
+       fi
+}
+
+run_test_picture ()
+{
+       if [ x"$FLAC__TEST_WITH_VALGRIND" = xyes ] ; then
+               echo "valgrind --leak-check=yes --show-reachable=yes --num-callers=50 test_picture $*" >>test_grabbag.valgrind.log
+               valgrind --leak-check=yes --show-reachable=yes --num-callers=50 --log-fd=4 test_picture${EXE} $* 4>>test_grabbag.valgrind.log
        else
-               test_cuesheet $*
+               test_picture${EXE} $*
        fi
 }
 
+if [ `env | grep -ic '^comspec='` != 0 ] ; then
+       is_win=yes
+else
+       is_win=no
+fi
+
+########################################################################
+#
+# test_picture
+#
+########################################################################
+
+log=picture.log
+picture_dir=pictures
+
+echo "Running test_picture..."
+
+rm -f $log
+
+run_test_picture $picture_dir >> $log 2>&1
+
+if [ $is_win = yes ] ; then
+       diff -w picture.ok $log > picture.diff || die "Error: .log file does not match .ok file, see picture.diff"
+else
+       diff picture.ok $log > picture.diff || die "Error: .log file does not match .ok file, see picture.diff"
+fi
+
+echo "PASSED (results are in $log)"
+
 ########################################################################
 #
 # test_cuesheet
@@ -50,6 +88,8 @@ good_cuesheets=cuesheets/good.*.cue
 good_leadout=`expr 80 \* 60 \* 44100`
 bad_leadout=`expr $good_leadout + 1`
 
+echo "Running test_cuesheet..."
+
 rm -f $log
 
 #
@@ -57,8 +97,7 @@ rm -f $log
 #
 for cuesheet in $bad_cuesheets ; do
        echo "NEGATIVE $cuesheet" >> $log 2>&1
-       run_test_cuesheet $cuesheet $good_leadout cdda >> $log 2>&1
-       exit_code=$?
+       run_test_cuesheet $cuesheet $good_leadout 44100 cdda >> $log 2>&1 || exit_code=$?
        if [ "$exit_code" = 255 ] ; then
                die "Error: test script is broken"
        fi
@@ -72,7 +111,7 @@ done
 #
 for cuesheet in $good_cuesheets ; do
        echo "POSITIVE $cuesheet" >> $log 2>&1
-       run_test_cuesheet $cuesheet $good_leadout cdda >> $log 2>&1
+       run_test_cuesheet $cuesheet $good_leadout 44100 cdda >> $log 2>&1
        exit_code=$?
        if [ "$exit_code" = 255 ] ; then
                die "Error: test script is broken"
@@ -85,6 +124,10 @@ for cuesheet in $good_cuesheets ; do
        rm -f $cuesheet_pass1 $cuesheet_pass2
 done
 
-diff cuesheet.ok $log > cuesheet.diff || die "Error: .log file does not match .ok file, see cuesheet.diff"
+if [ $is_win = yes ] ; then
+       diff -w cuesheet.ok $log > cuesheet.diff || die "Error: .log file does not match .ok file, see cuesheet.diff"
+else
+       diff cuesheet.ok $log > cuesheet.diff || die "Error: .log file does not match .ok file, see cuesheet.diff"
+fi
 
 echo "PASSED (results are in $log)"